import FreeCAD as App
import FreeCADGui as Gui

from kipy import KiCad

from . import settings
from .bases import BaseObject, BaseViewProvider

class APIObject(BaseObject):
    def __init__(self, parent, feature):
        super(APIObject, self).__init__(parent, feature)

        feature.addProperty('App::PropertyFile', 'Socket', 'KiConnect', 'Path to the KiCAD Socket File').Socket = '/tmp/kicad/api.lock'

    def execute(self, feature):
        self.parent.ping_connection()


class APIViewProvider(BaseViewProvider):
    pass

class API():
    ICON = 'icon_footprint_browser.svg'
    TYPE = 'KiConnect::API'

    def __init__(self):
        self.feature = App.ActiveDocument.addObject('App::FeaturePython', 'API')

        APIObject(self, self.feature)
        APIViewProvider(self, self.feature.ViewObject)

        self.kicad = KiCad()
        self.ping_connection()

    @property
    def is_connected(self):
        return self._connected

    def ping_connection(self):
        try:
            self.kicad.ping()
            self._connected = True
        except:
            self._connected = False
