class BaseObject:
    def __init__(self, parent, feature):
        print(self)
        self.parent = parent
        self.feature = feature

        feature.Proxy = self

        self.Type = ''

        if hasattr(parent.__class__, 'TYPE'):
            self.Type = parent.__class__.TYPE

        self.setup_properties()
        self.setup_extensions()

    def execute(self, feature):
        print('execute', feature.Label, self.Type)

    def setup_properties(self):
        pass

    def setup_extensions(self):
        if hasattr(self.parent.__class__, 'EXTENSIONS'):
            for ext in self.parent.__class__.EXTENSIONS:
                self.feature.addExtension(ext)

    def onBeforeChange(self, feature, prop):
        pass

    def onChanged(self, feature, prop):
        pass

    def __getstate__(self):
        return None
